import org.chemomentum.common.impl.gris.GridResourceInfoDownloadClient;
import org.w3.x2005.x08.addressing.EndpointReferenceType;
import org.chemomentum.common.ws.IGridResourceInformationService;
import org.chemomentum.common.impl.gris.attributes.ResponsiveAttribute;
import javax.xml.namespace.QName;
import org.chemomentum.common.impl.gris.ResourceObject;

try {

  if (commandLine.getArgs().size() > 2)
    throw new Exception("Wrong usage!");

  servOrchName = commandLine.args[1];

    List<EndpointReferenceType> eprs = null;
  try {
    eprs = registry.listAccessibleServices(IGridResourceInformationService.PORT);
  } catch (Exception e) {
    messageWriter.message 'Unable to contact Registry!';
    throw e;
  }
  myEpr = null;
  myUrl = null;

  eprs.each {
    myUrl = it.address.stringValue;
    if (myUrl.contains(servOrchName)) myEpr = it;
  }

  if (myEpr==null) throw new Exception("Unable to find this GRIS in the Registry!");

  messageWriter.verbose "Connecting to "+myUrl;
  grisClient = new GridResourceInfoDownloadClient(myUrl, myEpr, securityProperties);
  def candidates;
  try {
    candidates = grisClient.getAllComputationalResources([ResponsiveAttribute.KEY] as QName[]);
  } catch (org.codehaus.xfire.XFireRuntimeException e) {
    if (e.getCause().toString().contains("Problem when forwarding a client request to a VSite")) {
      throw new Exception("Some VSites are registered in GRIS but do not respond: "+e.getCause());
    }
    throw e;
  }

  counter = 0;
  candidates.each {
    counter++;
    messageWriter.verbose it.epr.address.stringValue
  }
  messageWriter.message "Sites found by GRIS: "+counter;
} catch (Exception e) {
  messageWriter.message e.getMessage();
  e.printStackTrace();
}

