import de.fzj.unicore.uas.client.*

if (commandLine.getArgs().size() != 2)
   throw new Exception("Wrong usage!");

site_name=commandLine.args[1];
list_registry=false
  
lister = new de.fzj.unicore.ucc.helpers.TargetSystemFactoryLister(registry ,securityProperties, messageWriter)

lister.each {
  // parse TSF Resource Properties and print TSF name
  def tsfRP = new XmlSlurper().parseText( it.getResourcePropertiesDocument().toString())
  if (site_name.contains(tsfRP.TargetSystemFactoryProperties.Name.toString())) {
    messageWriter.message "TSF name: "+tsfRP.TargetSystemFactoryProperties.Name.toString()

    // get number of TSSs avaiable in that TSF or try to create some
    if (tsfRP.TargetSystemFactoryProperties.AccessibleTargetSystemReference.size()==0) {
      try {
        it.createTSS();
      } catch (Exception e) {
        messageWriter.message "Problem when creating TSS:"
        e.printStackTrace();
        System.exit(2); 
      }
    }
  
    messageWriter.message "TSSs available: "+tsfRP.TargetSystemFactoryProperties.AccessibleTargetSystemReference.size().toString()
  }
}
