import org.w3.x2005.x08.addressing.EndpointReferenceType;
import org.chemomentum.common.ws.IWorkflowFactory;
import de.fzj.unicore.uas.client.BaseUASClient;
import org.chemomentum.workflow.xmlbeans.WorkflowFactoryPropertiesDocument; 

try {

  if (commandLine.getArgs().size() > 2)
    throw new Exception("Usage: run-groovy -f test_workflow.groovy WORKFLOW_SERVICE_NAME");

  workflowServiceName = (commandLine.getArgs().size() == 2 ? commandLine.getArgs()[1]: null);

    List<EndpointReferenceType> eprs = null;
  try {
    eprs = registry.listAccessibleServices(IWorkflowFactory.PORTTYPE);
  } catch (Exception e) {
    messageWriter.message 'Unable to contact Registry!';
    throw e;
  }
  myEpr = null;
  myUrl = null;
  foundWS = 0;

  eprs.each {
    myUrl = it.address.stringValue;
    if (workflowServiceName == null || myUrl.contains(workflowServiceName)) myEpr = it;
    foundWS++;
  }

  if (myEpr==null) throw new Exception("Unable to find this WorkflowFactory ("+workflowServiceName+") in the Registry!");

  if (foundWS !=1) throw new Exception("Found more than one matching WorkflowService in the Registry!");

  bc=new BaseUASClient(myEpr.address.getStringValue(),myEpr,securityProperties);
  rpd = bc.GetResourcePropertyDocument();
  if (rpd == null) {
    throw new Exception('WorkflowFactory service exists in Registry but doesn\'t respond!');
  }
  wfpd=WorkflowFactoryPropertiesDocument.Factory.parse(rpd.getGetResourcePropertyDocumentResponse().newInputStream());
  workflows = wfpd.getWorkflowFactoryProperties().getAccessibleWorkflowReferenceArray(); 
  messageWriter.message "Found " + workflows.size() + " available workflows";
} catch (Exception e) {
  messageWriter.message e.message;
  e.printStackTrace();
  return;
}
